package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ArithmeticCompositeExpr extends CompositeExpr {

    public ArithmeticCompositeExpr( Expr left, int oper, Expr right ) {
       super(left, oper, right);
    }

    public Type getType() {
        return left.getType();
    }

    public String getStringOper() {
       switch ( oper ) {
           case MySym.PLUS :
             return " + ";
           case MySym.MINUS :
             return " - ";
           case MySym.MULT :
             return "*";
           case MySym.DIV :
             return "/";
           case MySym.REMAINDER :
             return "%";
           case MySym.LEFTSHIFT :
             return " << ";
           case MySym.RIGHTSHIFT :
             return " >> ";
           default :
              ErrorMsg.signalFatalError("Unknown operator in ArithmeticCompositeExpr");
              return "";
       }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
