package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ArrayInitExprList extends Expr {

    public ArrayInitExprList(Expr left, ConstExprList exprList) {
       this.left = left;
       this.exprList = exprList;
    }

    public Type getType() {
        return exprList.getType();
    }

    public void gen( PrintWriter out, Context context ) {
       // $Array$1$int _a = new $Array$1$int(new int[] {2, 3, 5, 7, 11, 13 });
       
       ArrayType arrayType = (ArrayType ) left.getType();
       out.print("new " + left.getType().getJavaName() + 
           "( new " + arrayType.getType().getJavaName() + "[] {");
       //out.print("{ ");
       exprList.gen(out, context);
       out.print(" })");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr left;
    private ConstExprList exprList;

}
