package AST;

import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class AssertClause {

    public AssertClause(Expr beforeExpr, Expr afterExpr, AssertVariableList assertVariableList) {
       this.beforeExpr = beforeExpr;
       this.afterExpr = afterExpr;
       this.assertVariableList = assertVariableList;
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Expr getBeforeExpr() {
       return beforeExpr;
    }

    public Expr getAfterExpr() {
       return afterExpr;
    }

    public AssertVariableList getAssertVariableList() {
       return assertVariableList;
    }

    private Expr beforeExpr;
    private Expr afterExpr;
    private AssertVariableList assertVariableList;

}
