package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class AssignmentExpr extends Expr {

    public AssignmentExpr(Expr left, Expr right) {
       this.left = left;
       this.right = right;
    }

    public boolean getIsLeftValue() {
        return right.getIsLeftValue();
    }

    public Object getValue() {
        return right.getValue();
    }

    public Type getType() {
       return left.getType();
    }

    public void gen( PrintWriter out, Context context ) {
       left.gen(out, context);
       out.print(" = ");
       right.gen(out, context, false);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr left;
    private Expr right;

}
