package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class AtType extends Type {

    public AtType(Type type) {
        super(type.getName());
        this.type = type;
    }

    public String getInterfaceName() {
        return type.getInterfaceName();
    }

    public TypeInterface getTypeInterface() {
        return type.getTypeInterface();
    }

    public void setTypeInterface(TypeInterface type) {
        this.setTypeInterface(type);
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
        type.reify(til, em);
    }

    public String getJavaName() {
        return type.getJavaName();
    }

    public String getGreenName() {
        return type.getGreenName();
    }

    public String getSearchName() {
        return type.getSearchName();
    }

    public String getName() {
        return type.getName();
    }

    public boolean isSupertypeOf(Type other) {
        return type.isSupertypeOf(other);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Type getType() {
       return type;
    }

    private Type type;

}
