package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class AttachShellStatement extends MetaStatement {

    public AttachShellStatement( Variable variable, ClassType shellClass ) {
         super(variable);
         this.shellClass = shellClass;
    }

    public void gen( PrintWriter out, Context context ) {
         ClassTypeInterface attached = 
           (ClassTypeInterface ) 
             ((ClassTypeInterface ) shellClass
                  .getTypeInterface()).getAttachedType().getTypeInterface();
         ClassTypeInterface shellInterface = (ClassTypeInterface ) shellClass.getTypeInterface();
         if ( attached.getIsReflective() ) 
            ws.println( "((_ReflectiveAnyClass ) " + 
               getVariable().getJavaName() + ").sv = new " + 
               shellInterface.getShell_ivcName() + "();" );
         else
            ws.println( shellInterface.getJavaName() + ".ht.put( " + 
               getVariable().getJavaName() + ", new " + 
               shellInterface.getShell_ivcName() + "() );" );
         ws.println( "// call C function changeClass( " + getVariable().getJavaName() +
           ", " + shellInterface.getJavaName() + ".class);");
         ws.println("// a primitive simulation of shells");
         ws.println( getVariable().getJavaName() + " = new " + 
            shellInterface.getJavaName() + "();" );
         ws.println("// the code below will be removed after the C function attachShell is ready");
         if ( attached.getIsReflective() ) 
            ws.println( "((_ReflectiveAnyClass ) " + 
               getVariable().getJavaName() + ").sv = new " + 
               shellInterface.getShell_ivcName() + "();" );
           
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public ClassType getShellClass() {
       return shellClass;
    }

    public void setShellClass( ClassType shellClass ) {
       this.shellClass = shellClass;
    }

    private ClassType shellClass;

}
