package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class BlockStatement extends Statement {

    public BlockStatement(StatementList statementList) {
       this.statementList = statementList;
    }

    public void gen( PrintWriter out, Context context ) {
       if ( statementList != null ) 
          statementList.gen(out, context);
    }

    public int getSize() {
        return statementList.getSize();
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private StatementList statementList;

}
