package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class BooleanCompositeExpr extends CompositeExpr {

    public BooleanCompositeExpr( Expr left, int oper, Expr right ) {
       super(left, oper, right);
    }

    public Type getType() {
       return Type.booleanType;
    }

    public String getStringOper() {
       switch ( oper ) {
           case MySym.AND :
             return " && ";
           case MySym.OR :
             return " || ";
           case MySym.XOR :
             return " ^ ";
           default :
              ErrorMsg.signalFatalError("Unknown operator in BooleanCompositeExpr");
              return "";
       }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
