package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ByteType extends BasicType {

    public ByteType() {
       super("byte");
       //setSuperclass( new ClassType("AnyValue", null, false) );
    }

    public Type getWrapperType() {
         return Type.wrapperByteType;
    }

    public String getJavaZeroValue() {
         return "0";
    }

    public String genToWrapper(String expr) {
       return "Byte.new(" + expr + ")";
    }

    public String genFromWrapper(String expr) {
       return "((Byte ) " + expr + ").byteValue()";
    }

    public String getJavaWrapperName() {
        return "_Byte";
    }

    public String getJavaName() {
        return "byte";
    }

    public String getWrapperName() {
        return "Byte";
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
