package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class CharType extends BasicType {

    public CharType() {
       super("char");
       //setSuperclass( new ClassType("AnyValue", null, false) );
    }

    public Type getWrapperType() {
         return Type.wrapperCharType;
    }

    public String getJavaZeroValue() {
         return "'\0'";
    }

    public String genToWrapper(String expr) {
       return "Character.new(" + expr + ")";
    }

    public String genFromWrapper(String expr) {
       return "((Character) " + expr + ").charValue()";
    }

    public String getJavaWrapperName() {
        return "_Char";
    }

    public String getJavaName() {
        return "char";
    }

    public String getWrapperName() {
        return "Char";
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
