package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ClassConstantExpr extends Expr {

    public ClassConstantExpr(ClassObjectTypeInterface coti, Constant constant) {
       this.coti = coti;
       this.constant = constant;
    }

    public Object getValue() {
        return constant.getValue();
    }

    public Type getType() {
        return constant.getType();
    }

    public void gen( PrintWriter out, Context context ) {
       out.print( coti.getJavaName() + "." + constant.getJavaName());
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private ClassObjectTypeInterface coti;
    private Constant constant;

}
