package AST;

import java.lang.*;
import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ClassObjectVariable extends InstanceVariable {

    public ClassObjectVariable( String name, int ivNumber ) {
       super(name, ivNumber);
    }

    public void genDeclaration( PrintWriter out, Context context ) {
        ws.print( "public " );
        Type t = getType();
        if ( t instanceof BasicType || 
             t.getIsJavaClass() ||
             GreenProject.subtypeEqualSubclass ||
             t.isArrayType()  
             ) 
           out.print( getType().getJavaName() );
        else
           out.print( "_Any" );
        out.print(" " + getJavaName());
        if ( expr != null ) {
           out.print(" = ");
           expr.gen(out, context);
        }
        out.println(";");
    }

    public void genI(PrintWriter out) {
         WhiteSpace.printMember(out);
         out.println("var " + getName() + " : " + getType().getGreenName() + ";");
    }

    public void setExpr( Expr expr ) {
       this.expr = expr;
    }

    private Expr expr;

}
