package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ClassObjectVariableList {

    public ClassObjectVariableList() {
       varList = new Vector();
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
         Enumeration e = varList.elements();
         while ( e.hasMoreElements() ) {
            ClassObjectVariable v = (ClassObjectVariable ) e.nextElement();
            v.reify(til, em);
         }
    }

    public Enumeration elements() {
        return varList.elements();
    }

    public int getSize() {
        return varList.size();
    }

    public void add(ClassObjectVariable aVariable) {
       varList.addElement(aVariable);
    }

    public void gen( PrintWriter out, Context context ) {
        out.println();
        ws.add();
        Enumeration e = varList.elements();
        while ( e.hasMoreElements() ) 
           ((ClassObjectVariable ) e.nextElement()).genDeclaration(out, context);
        ws.sub();
    }

    public void genI(PrintWriter out) {
        Enumeration e = varList.elements();
        while ( e.hasMoreElements() ) 
           ((ClassObjectVariable ) e.nextElement()).genI(out);
    }

    public void genCaseSet(PrintWriter out) {
         Enumeration e = varList.elements();
         while ( e.hasMoreElements() )
            ((ClassObjectVariable ) e.nextElement()).genCaseSet(out);
    }

    public void genCaseGet(PrintWriter out) {
         Enumeration e = varList.elements();
         while ( e.hasMoreElements() )
            ((ClassObjectVariable ) e.nextElement()).genCaseGet(out);
    }

    public void genObjectInstanceVariableInfo(PrintWriter out) {
         int size = varList.size();
         Enumeration e = varList.elements();
         while ( e.hasMoreElements() ) {
            ((ClassObjectVariable ) e.nextElement()).genObjectInstanceVariableInfo(out);
            if ( --size > 0 )
               out.println(",");
            else
               out.println();
         }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Vector getVarList() {
       return varList;
    }

    private Vector varList;

}
