package AST;

import java.lang.*;
import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

abstract public class CompositeExpr extends Expr {

    public CompositeExpr( Expr left, int oper, Expr right ) {
        this.left = left;
        this.oper = oper;
        this.right = right;
    }

    abstract public String getStringOper();

    public void gen( PrintWriter out, Context context ) {
       gen(out, context, true);
    }

    public void gen( PrintWriter out, Context context, boolean useParenthesis ) {
       if ( left.getType() == Type.byteType &&
            (oper == MySym.PLUS ||
             oper == MySym.MINUS ||
             oper == MySym.MULT ||
             oper == MySym.DIV ||
             oper == MySym.REMAINDER ||
             oper == MySym.LEFTSHIFT ||
             oper == MySym.RIGHTSHIFT ||
             oper == MySym.BINAND ||
             oper == MySym.BINOR ||
             oper == MySym.BINXOR ||
             oper == MySym.BINNOT)   ) {
          out.print( "(byte ) " );
          useParenthesis = true;
       }
       if ( useParenthesis )
          out.print("(");
       left.gen(out, context);
       out.print( getStringOper() );
       right.gen(out, context);
       if ( useParenthesis )
          out.print(")");
    }

    protected Expr left;
    protected Expr right;
    protected int oper;

}
