package AST;

import java.lang.*;
import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ConstList {

    public ConstList() {
       constList = new Vector();
    }

    public void add(Constant constant) {
       constList.addElement(constant);
    }

    public Enumeration elements() {
        return constList.elements();
    }

    public int getSize() {
        return constList.size();
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
        Enumeration e = constList.elements();
        while ( e.hasMoreElements() ) {
           Constant c = (Constant ) e.nextElement();
           c.reify(til, em);
        }
    }

    public void gen( PrintWriter out, Context context, String prefix ) {
        ws.add();
        Enumeration e = constList.elements();
        while ( e.hasMoreElements() ) {
           Constant c = (Constant ) e.nextElement();
           ws.print(prefix);
           c.gen(out, context);
        }
        ws.sub();
    }

    public void genI(PrintWriter out) {
        Enumeration e = constList.elements();
        while ( e.hasMoreElements() ) {
           Constant c = (Constant ) e.nextElement();
           c.genI(out);
        }
    }

    public void genConstantInfo( PrintWriter out, boolean putComma ) {
         int size = constList.size();
         Enumeration e = constList.elements();
         while ( e.hasMoreElements() ) {
            ((Constant ) e.nextElement()).genConstantInfo(out);
            if ( --size > 0 )
               out.println(",");
         }
         if ( putComma ) 
            out.println(",");
         else
            out.println();
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Vector constList;

}
