package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ConstantExpr extends Expr {

    public ConstantExpr(Constant constant) {
       this.constant = constant;
    }

    public Object getValue() {
        return constant.getValue();
    }

    public Type getType() {
        return constant.getType();
    }

    public void gen( PrintWriter out, Context context ) {
       out.print(constant.getJavaName());
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Constant constant;

}
