package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class Context {

    public Context(GenericClass currentClass, Method currentMethod, CompilerOptions compilerOptions) {
       this.currentClass = currentClass;
       this.currentMethod = currentMethod;
       this.compilerOptions = compilerOptions;
    }

    public String getCatchVariableName() {
         return "$aCatch" + catchNumber++;
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public GenericClass getCurrentClass() {
       return currentClass;
    }

    public void setCurrentClass( GenericClass currentClass ) {
       this.currentClass = currentClass;
    }

    public Method getCurrentMethod() {
       return currentMethod;
    }

    public void setCurrentMethod( Method currentMethod ) {
       this.currentMethod = currentMethod;
    }

    public CompilerOptions getCompilerOptions() {
       return compilerOptions;
    }

    public void setCompilerOptions( CompilerOptions compilerOptions ) {
       this.compilerOptions = compilerOptions;
    }

    private GenericClass currentClass;
    private Method currentMethod;
    private CompilerOptions compilerOptions;
    private int catchNumber;

}
