package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class EachCase extends Statement {

    public EachCase(ConstExprList constExprList, Statement statement) {
       this.constExprList = constExprList;
       this.statement = statement;
    }

    public void gen( PrintWriter out, Context context ) {
       Enumeration e = constExprList.elements();
       while ( e.hasMoreElements() ) {
           ws.print("case ");
           ((Expr ) e.nextElement()).gen(out, context);
           out.println(" :");
       }
       ws.add();
       statement.gen(out, context);
       ws.println("break;");
       ws.sub();
    }

    public void genIf( PrintWriter out, Context context, boolean isLast ) {
       Enumeration e = constExprList.elements();
       while ( e.hasMoreElements() ) {
           ws.print("if ( $any == ");
           ((Expr ) e.nextElement()).gen(out, context);
           out.println(" ) {");
           statement.gen(out, context);
           ws.println("}");
           if ( ! isLast ) {
               ws.println("else ");
           }
       }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private ConstExprList constExprList;
    private Statement statement;

}
