package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ExceptionExpr extends Expr {

    public ExceptionExpr(MethodInterface methodInterface, Expr expr) {
       this.methodInterface = methodInterface;
       this.expr = expr;
    }

    public Type getType() {
        return null;
    }

    public void gen( PrintWriter out, Context context ) {
       String runtimeString = NameServer.getAccessToClassObject("Runtime");
       out.print( runtimeString  + "._$setMethodThrownException$_ObjectMethodInfo(");
       out.println( NameServer.getObjectMethodInfoNameVar( context.getCurrentMethod().getName(),
            context.getCurrentMethod().getParamList() ) + ");" );
       
       ws.print("throw new PackedException( ");
       expr.gen(out, context, false);
       out.print(" )");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public MethodInterface getMethodInterface() {
       return methodInterface;
    }

    public Expr getExpr() {
       return expr;
    }

    private MethodInterface methodInterface;
    private Expr expr;

}
