package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ForStatement extends Statement {

    public ForStatement(Variable variable, Expr exprFrom, Expr exprTo, Statement statement, boolean declareVariable) {
       this.variable = variable;
       this.exprFrom = exprFrom;
       this.exprTo = exprTo;
       this.statement = statement;
       this.declareVariable = declareVariable;
    }

    public void gen( PrintWriter out, Context context ) {
       ws.println("{ ");
       ws.add();
       if ( declareVariable )
          ((LocalVariable ) variable).genDeclaration(out);
       ws.print( variable.getJavaName() + " = ");
       exprFrom.gen(out, context, false);
       out.println(";");
       ws.print( exprTo.getType().getJavaName() +
             " $exprTo" + variable.getJavaName() + " = ");
       exprTo.gen(out, context, false);
       out.println(";");
       ws.println( "for( ; " + variable.getJavaName() + 
                    " <= $exprTo" + variable.getJavaName() + "; " 
                    + variable.getJavaName() + "++ ) {");
       ws.add();                 
       statement.gen(out, context);
       ws.sub();
       ws.println("}");
       ws.sub();
       ws.println("}");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Variable getVariable() {
       return variable;
    }

    private Variable variable;
    private Expr exprFrom;
    private Expr exprTo;
    private Statement statement;
    private boolean declareVariable;

}
