package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class IfStatement extends Statement {

    public IfStatement(Expr expr, StatementList thenStatementList, StatementList elseStatementList) {
       this.expr = expr;
       this.thenStatementList = thenStatementList;
       this.elseStatementList = elseStatementList;
    }

    public void gen( PrintWriter out, Context context ) {
       ws.print("if ( ");
       expr.gen(out, context, false);
       out.println(" ) {");
       if ( thenStatementList != null ) {
         ws.add();
         thenStatementList.gen(out, context);
         ws.sub();
       }
       if ( elseStatementList != null ) {
         ws.println("}");
         ws.println("else {");
         ws.add();
         elseStatementList.gen(out, context);
         ws.sub();
       }
       ws.println("}");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr expr;
    private StatementList thenStatementList;
    private StatementList elseStatementList;

}
