package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class InitMethod extends Method {

    public InitMethod(int methodNumber) {
       super("init", false, methodNumber);
       setIsInitMethod(true);
    }

    public void genClassMethodInfo(PrintWriter out) {
         ws.println("{");
         ws.add();
         // getParamList().genDeclarationParameter(out);
         Enumeration e = getParamList().elements();
         while ( e.hasMoreElements() ) {
            Parameter p = (Parameter ) e.nextElement();
            ws.println("_ParameterInfo " + p.getParameterInfoVarName() + 
                //m
                " = (_ParameterInfo ) _ParameterInfo.$classObject._new$String$_ClassInfo$_MethodInfo$$Array$1$_CodeAnnotation$_Boolean(\"" + p.getName() + "\", " + 
                ((ClassTypeInterface ) p.getType().getTypeInterface()).getAccessToClassInfo()
                   + ", null, null, false);" );
         }
         ws.println( getClassMethodInfoNameVar() + " = (_ClassInitMethodInfo ) _ClassInitMethodInfo.$classObject._new$_MethodBodyInfo$$Array$1$_ClassInfo$$Array$1$_ParameterInfo$_ClassInfo$$Array$1$_CodeAnnotation(");
         ws.add();
         
         ws.println("null,");
         
         ws.println("new " + NameServer.buildArrayName("_ClassInfo", 1) + "(");
         ws.add();
         ws.println( "new _ClassInfo[] { ");
         ws.add();
         e = getParamList().elements();
         int size = getParamList().getSize();
         while ( e.hasMoreElements() ) {
            Parameter p = (Parameter ) e.nextElement();
            ws.print(  ((ClassTypeInterface ) p.getType().getTypeInterface()).getAccessToClassInfo() );
            if ( --size > 0 )
               out.println(",");
            else
               out.println();
         }
         ws.println("}");
         ws.sub();
         ws.println("),");
         ws.sub();
         ws.println("new " + NameServer.buildArrayName("_ParameterInfo", 1) + "(");
         ws.add();
         ws.println("new _ParameterInfo[] {");
         ws.add();
         e = getParamList().elements();
         size = getParamList().getSize();
         while ( e.hasMoreElements() ) {
            Parameter p = (Parameter ) e.nextElement();
            ws.print(  p.getParameterInfoVarName() );
            if ( --size > 0 )
               out.println(",");
            else
               out.println();
         }
         ws.println("}");
         ws.sub();
         ws.println("),");
         ws.sub();
         if ( getExceptionType() == null ) 
            ws.println("null,");
         else 
            ws.println( ( (ClassTypeInterface ) getExceptionType().getTypeInterface())
                  .getAccessToClassInfo() + ","  );
         ws.println("null");
         ws.println(");");
         
         ws.sub();
         e = getParamList().elements();
         while ( e.hasMoreElements() ) {
            Parameter p = (Parameter ) e.nextElement();
            ws.println( p.getParameterInfoVarName() + "._$setDeclaringMethod$_MethodInfo(" +
               getClassMethodInfoNameVar() + ");" );
         }
         
         ws.sub();
         ws.println("}");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
