package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class InstanceVariableList {

    public InstanceVariableList() {
       instanceVariableList = new Vector();
    }

    public void add(InstanceVariable instanceVariable) {
       instanceVariableList.addElement( instanceVariable );
    }

    public Enumeration elements() {
        return instanceVariableList.elements();
    }

    public int getSize() {
        return instanceVariableList.size();
    }

    public void gen(PrintWriter out) {
        gen(out, Method.private_v);
    }

    public void gen( PrintWriter out, int visibility ) {
        out.println();
        ws.add();
        Enumeration e = instanceVariableList.elements();
        while ( e.hasMoreElements() ) 
           ((InstanceVariable ) e.nextElement()).genDeclaration(out, visibility);
        ws.sub();
    }

    public void genI(PrintWriter out) {
         out.println("      var");
         InstanceVariable iv;
         Enumeration e = instanceVariableList.elements();
         while ( e.hasMoreElements() ) {
            iv = (InstanceVariable ) e.nextElement();
            iv.genI(out);
         }
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
         InstanceVariable iv;
         Enumeration e = instanceVariableList.elements();
         while ( e.hasMoreElements() ) {
            iv = (InstanceVariable ) e.nextElement();
            iv.reify(til, em);
         }
    }

    public void genCaseSet(PrintWriter out) {
         Enumeration e = instanceVariableList.elements();
         while ( e.hasMoreElements() )
            ((InstanceVariable ) e.nextElement()).genCaseSet(out);
    }

    public void genCaseGet(PrintWriter out) {
         Enumeration e = instanceVariableList.elements();
         while ( e.hasMoreElements() )
            ((InstanceVariable ) e.nextElement()).genCaseGet(out);
    }

    public void genVariableInfo(PrintWriter out) {
         int size = instanceVariableList.size();
         Enumeration e = instanceVariableList.elements();
         while ( e.hasMoreElements() ) {
            ((InstanceVariable ) e.nextElement()).genVariableInfo(out);
            if ( --size > 0 )
               out.println(",");
         }
         if ( instanceVariableList.size() > 0 )
            out.println();
    }

    public void genObjectInstanceVariableInfo(PrintWriter out) {
         int size = instanceVariableList.size();
         Enumeration e = instanceVariableList.elements();
         while ( e.hasMoreElements() ) {
            ((InstanceVariable ) e.nextElement()).genObjectInstanceVariableInfo(out);
            if ( --size > 0 )
               out.println(",");
            else
               out.println();
         }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Vector instanceVariableList;

}
