package AST;

import java.lang.*;
import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class LiteralCharConst extends LiteralConstExpr {

    public LiteralCharConst(String value) {
       this.value = value;
    }

    public Object getValue() {
        return value;
    }

    public String getStringValue() {
        return value;
    }

    public Type getType() {
        return Type.charType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print( "'" + value + "'");
    }

    public void genI(PrintWriter out) {
       out.print(value);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private String value;

}
