package AST;

import java.lang.*;
import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class LiteralIntegerConst extends LiteralConstExpr {

    public LiteralIntegerConst(int value) {
       this.value = value;
    }

    public Object getValue() {
        return new Integer(value);
    }

    public String getStringValue() {
        return (new Integer(value)).toString();
    }

    public Type getType() {
        return Type.integerType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print(value);
    }

    public void genI(PrintWriter out) {
       out.print(value);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private int value;

}
