package AST;

import java.lang.*;
import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class LiteralLongConst extends LiteralConstExpr {

    public LiteralLongConst(long value) {
       this.value = value;
    }

    public Object getValue() {
        return new Long(value);
    }

    public String getStringValue() {
        return (new Long(value)).toString();
    }

    public Type getType() {
        return Type.longType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print(value);
    }

    public void genI(PrintWriter out) {
       out.print(value);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private long value;

}
