package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class LocalVariableList {

    public LocalVariableList() {
        varList = new Vector();
    }

    public void add(LocalVariable localVariable) {
       varList.add(localVariable);
    }

    public void gen(PrintWriter out) {
       ws.add();
       Enumeration e = varList.elements();
       while ( e.hasMoreElements() ) {
         LocalVariable p = (LocalVariable ) e.nextElement();
         p.genDeclaration(out);
       }
       ws.sub();
    }

    public Enumeration elements() {
        return varList.elements();
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
        Enumeration e = varList.elements();
        while ( e.hasMoreElements() ) 
           ((LocalVariable ) e.nextElement()).reify(til, em);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Vector varList;

}
