package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class LongType extends BasicType {

    public LongType() {
       super("long");
       //setSuperclass( new ClassType("AnyValue", null, false) );
    }

    public Type getWrapperType() {
         return Type.wrapperLongType;
    }

    public String getJavaZeroValue() {
         return "0L";
    }

    public String genToWrapper(String expr) {
       return "Long.new(" + expr + ")";
    }

    public String genFromWrapper(String expr) {
       return "((Long ) " + expr + ").longValue()";
    }

    public String getJavaWrapperName() {
        return "_Long";
    }

    public String getJavaName() {
        return "long";
    }

    public String getWrapperName() {
        return "Long";
    }

    static final int sizeInBytes = 8;

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
