package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class LoopStatement extends Statement {

    public LoopStatement(StatementList statementList) {
       this.statementList = statementList;
    }

    public void gen( PrintWriter out, Context context ) {
       if ( statementList.getSize() > 1 )
         ws.println("while (true) {");
       else
         ws.println("while (true)");
       ws.add();
       statementList.gen(out, context);
       ws.sub();
       ws.println("}");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private StatementList statementList;

}
