package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class MessageSendToSuperExpr extends Expr {

    public MessageSendToSuperExpr(MethodInterface methodInterface, ExprList paramList) {
       this.methodInterface = methodInterface;
       this.paramList = paramList;
    }

    public Type getType() {
        return methodInterface.getReturnType();
    }

    public void gen( PrintWriter out, Context context ) {
       out.print("super." + methodInterface.getJavaName() + "(");
       paramList.gen(out, context);
       out.print(")");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private MethodInterface methodInterface;
    private ExprList paramList;

}
