package AST;

import java.lang.*;
import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class MethodList {

    public MethodList() {
       methodList = new Vector();
    }

    public void add(Method aMethod) {
       methodList.addElement( aMethod );
    }

    public Enumeration elements() {
       return methodList.elements();
    }

    public Method search(String searchName) {
        Enumeration e = methodList.elements();
        Method m;
        while ( e.hasMoreElements() ) 
           if ( searchName.compareTo( (m = (Method ) e.nextElement()).getSearchName()) == 0 )
              return m;
        return null;
    }

    public void gen( PrintWriter out, boolean isBasicType, Context context ) {
        sort();
        Enumeration e = methodList.elements();
        Method m;
        while ( e.hasMoreElements() ) {
           out.println();
           m = (Method ) e.nextElement();
           m.gen(out, isBasicType, context);
        }
    }

    public int getSize() {
        return methodList.size();
    }

    public void sort() {
         int k;
         Method m;
         int size = methodList.size();
         if ( size > 1 ) {
            for (int i = 0; i < size; i++) {
               m = (Method ) methodList.elementAt(i);
               String smaller = m.getSearchName();
               k = i;
               for (int j = i + 1; j < size; j++)
                  if ( ((Method ) methodList.elementAt(j)).getSearchName().compareTo(smaller) < 0 ) {
                     m = (Method ) methodList.elementAt(j);
                     smaller = m.getSearchName();
                     k = j;
                  }
               if ( k != i ){
                  Method aux = (Method ) methodList.elementAt(i);
                  methodList.setElementAt( m, i );
                  methodList.setElementAt( aux, k );
               }
                     
            }
         }
    }

    public void genCaseCallMethod(PrintWriter out) {
         Enumeration e = methodList.elements();
         while ( e.hasMoreElements() ) 
            ((Method ) e.nextElement()).genCaseCallMethod(out);
    }

    public void genObjectMethodInfoVarList( PrintWriter out, boolean putComma ) {
         int size = methodList.size();
         Enumeration e = methodList.elements();
         while ( e.hasMoreElements() ) {
            ws.print( ((Method) e.nextElement()).getObjectMethodInfoNameVar() );
            if ( --size > 0 )
               out.println(",");
         }
         if ( putComma ) 
            out.println(",");
         else
            out.println();
    }

    public void genClassMethodInfoVarList( PrintWriter out, boolean putComma ) {
         int size = methodList.size();
         Enumeration e = methodList.elements();
         while ( e.hasMoreElements() ) {
            ws.print( ((Method) e.nextElement()).getClassMethodInfoNameVar() );
            if ( --size > 0 )
               out.println(",");
         }
         if ( putComma )
            out.println(",");
         else if ( methodList.size() > 0 )
            out.println();
    }

    public void genObjectMethodInfoList( PrintWriter out, boolean putComma ) {
         Enumeration e = methodList.elements();
         int size = 0;
         while ( e.hasMoreElements() ) 
            if ( ((Method ) e.nextElement()).getName().compareTo("new") != 0 ) 
               size++;
         boolean printed = size > 0;
         
         e = methodList.elements();
         while ( e.hasMoreElements() ) {
            Method m = (Method) e.nextElement();
            if ( m.getName().compareTo("new") != 0 ) {
               ws.print( m.getObjectMethodInfoNameVar() );
               if ( --size > 0 )
                  out.println( "," );
            }
         }
         if ( putComma && printed ) 
            out.println(",");
         else
            out.println();
    }

    public void genNewObjectMethodInfoList(PrintWriter out) {
         boolean first = true;
         Enumeration e = methodList.elements();
         while ( e.hasMoreElements() ) {
            Method m = (Method) e.nextElement();
            if ( m.getName().compareTo("new") == 0 ) {
               if ( ! first )
                  out.println(",");
               ws.print( m.getObjectMethodInfoNameVar() );
               first = false;
            }
         }
         out.println();
    }

    public void genObjectMethodInfo(PrintWriter out) {
         Enumeration e = methodList.elements();
         while ( e.hasMoreElements() ) {
            ((Method ) e.nextElement()).genObjectMethodInfo(out);
         }
    }

    public void genClassMethodInfo(PrintWriter out) {
         Enumeration e = methodList.elements();
         while ( e.hasMoreElements() ) {
            ((Method ) e.nextElement()).genClassMethodInfo(out);
         }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Vector getMethodList() {
       return methodList;
    }

    private Vector methodList;

}
