package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ParameterList {

    public ParameterList() {
        paramList = new Vector();
    }

    public void add(Parameter param) {
       paramList.addElement(param);
    }

    public Enumeration elements() {
       return paramList.elements();
    }

    public int getSize() {
        return paramList.size();
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
        Enumeration e = paramList.elements();
        while ( e.hasMoreElements() ) 
           ((Parameter ) e.nextElement()).reify(til, em);
    }

    public void genI( PrintWriter out, int skipFactor ) {
         // skipFactor is used when parameters should be put in more than one line
       int size = paramList.size();
       int skipLine = 1;
       Enumeration e = paramList.elements();
       while ( e.hasMoreElements() ) {
         Parameter p = (Parameter ) e.nextElement();
         out.print(p.getName() + " : ");
         out.print(p.getType().getGreenName());
         if ( --size > 0 ) {
            out.print("; ");
            if ( skipLine%2 == 0 ) {
               out.println();
               WhiteSpace.printMember(out);
               WhiteSpace.print(out, skipFactor + 7);
            }
         }
         skipLine++;
       }
    }

    public void gen(PrintWriter out) {
         // skipFactor is used when parameters should be put in more than one line
       int size = paramList.size();
       int skipLine = 1;
       Enumeration e = paramList.elements();
       while ( e.hasMoreElements() ) {
         Parameter p = (Parameter ) e.nextElement();
         p.genDeclaration(out);
         if ( --size > 0 ) {
            out.print(", ");
            if ( skipLine%2 == 0 ) {
               out.println();
               WhiteSpace.printIndent(out);
               WhiteSpace.printIndent(out);
            }
         }
         skipLine++;
       }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Vector getParamList() {
       return paramList;
    }

    private Vector paramList;

}
