package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class RelationExpr extends CompositeExpr {

    public RelationExpr( Expr left, int oper, Expr right ) {
       super(left, oper, right);
    }

    public Type getType() {
       return Type.booleanType;
    }

    public String getStringOper() {
       switch ( oper ) {
           case MySym.GT :
             return " > ";
           case MySym.GE :
             return " >= ";
           case MySym.LT :
             return " < ";
           case MySym.LE :
             return " <= ";
           case MySym.EQ :
             return " == ";
           case MySym.NEQ :
             return " != ";
           default :
              ErrorMsg.signalFatalError("Unknown operator in RelationExpr");
              return "";
       }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
