package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class RepeatStatement extends Statement {

    public RepeatStatement(StatementList statementList, Expr expr) {
       this.statementList = statementList;
       this.expr = expr;
    }

    public void gen( PrintWriter out, Context context ) {
       ws.println("do {");
       ws.add();
       statementList.gen(out, context);
       ws.sub();
       ws.println("} while ( ");
       if ( expr instanceof NotUnaryExpr )
         ((NotUnaryExpr ) expr).getRight().gen(out, context, false);
       else {
         out.print("! ");
         expr.gen(out, context);
       }
       ws.println(" );");  
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private StatementList statementList;
    private Expr expr;

}
