package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class ReturnStatement extends Statement {

    public ReturnStatement(Expr expr, boolean hasAssertAfter) {
       this.expr = expr;
       this.hasAssertAfter = hasAssertAfter;
    }

    public void gen( PrintWriter out, Context context ) {
       if ( hasAssertAfter ) {
          if ( expr == null ) 
             ws.println("break $fim;");
          else {
             ws.print("{ ");
             out.print("$return = ");
             expr.gen(out, context, false);
             out.println(";");
             ws.println("  break $fim;");
             ws.println("}");
          }
       }
       else {
          ws.print("return ");
          if ( expr != null ) 
            expr.gen(out, context, false);
          out.println(";");
       }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr expr;
    private boolean hasAssertAfter;

}
