package AST;

import java.lang.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class TypeOfClass extends TypeOf {

    public TypeOfClass(Type classType) {
       this.classType = classType;
    }

    public TypeOfClass( Type classType, TypeInterface typeInterface ) {
         this.classType = classType;
         setTypeInterface(typeInterface);
    }

    public String getName() {
         return classType.getName();
    }

    public String getInterfaceName() {
         return getTypeInterface().getName();
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
         classType.reify(til, em);
         setTypeInterface( ((ClassTypeInterface ) classType.getTypeInterface()).getClassObjectInterface() );
    }

    public String getGreenName() {
         return "type(" + classType.getGreenName() + ")";
    }

    public String getJavaName() {
         // return classType.getJavaName();
         return getTypeInterface().getJavaName();
    }

    public boolean isSupertypeOf(Type other) {
         return classType.isSupertypeOf(other);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Type getClassType() {
       return classType;
    }

    private Type classType;

}
