package AST;

import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

abstract public class UnaryExpr extends Expr {

    public Type getType() {
       return right.getType();
    }

    public UnaryExpr( int oper, Expr right ) {
       this.oper = oper;
       this.right = right;
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Expr getRight() {
       return right;
    }

    protected Expr right;
    protected int oper;

}
