package AST;

import java.io.*;
import java.util.*;
import GreenCompiler.*;
import CompilerError.*;
import Interface.*;

public class VarDecStatement extends Statement {

    public VarDecStatement(LocalVariable localVariable, Expr expr) {
       this.localVariable = localVariable;
       this.expr = expr;
    }

    public void gen( PrintWriter out, Context context ) {
        Type t = localVariable.getType();
        if ( t instanceof BasicType || 
             GreenProject.subtypeEqualSubclass ||
             t.getIsJavaClass() ||
             t.isArrayType()  
             )
           ws.print( t.getJavaName() );
        else
           ws.print( "_Any" );
        out.print(" " + localVariable.getJavaName() );
       
        if ( expr != null ) {
           out.print(" = ");
           expr.gen(out, context);
        }
        out.println(";");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private LocalVariable localVariable;
    private Expr expr;

}
