// $Array$2$_integer is the array class name
// _integer is the type of the array elements in Green
// _Integer is the wrapper class name associated to _integer in Green
// int is the java name for the array element type

// not used : @ is the array class name
// ^ is the type of the array elements in Green
// # is the wrapper class name associated to ^ in Green
// ? is the java name for the array element type


class $Array$2$_^ subclassOf AnyArray

      proc init( size : integer ) 
         begin
         java$begin
         v = new ?[size = _size][];
         java$end
         end

      proc init( size, numColumns : integer ) 
         begin
         java$begin
         v = new ?[size = _size][_numColumns];
         java$end
         end
   
   public:
      proc getSize() : integer
         begin
         java$begin
         return size;
         java$end
         end
         
      proc toString() : String
         begin
         java$begin
         StringBuffer s = new StringBuffer("{ ");
         int n = size - 1;
         i = 0;
         while ( i < size ) {
             StringBuffer p = new StringBuffer("{ ");
             if ( v[i] != null ) {
                j = 0;
                int length = v[i].length;
                int m = lenght - 1;
                while ( j < lenght ) {
                    p.append(v[i][j].toString());
                    if ( j < m )
                       p.append(", ");
                    j++;
                }
                p.append(" }");
             }
             s.append( p ) ;
             if ( i < n ) 
                 s.append(", ");
             i++;
         }
         s.append(" }");
         return s.toString();
         java$end
         end
         
      proc get( i : integer ) 
              (exception : CatchAnyArrayException) : Any
         begin
         java$begin
         if ( _i >= size || _i < 0 )
            throw new _IllegalArrayIndexException();
         else
            return v[_i];
         java$end
         end
         
      proc get( i, j : integer )
              (exception : CatchAnyArrayException) : Any
         begin
         java$begin
         if ( _i >= size || _i < 0 || 
              v[_i] == null ||
              _j >= v[_i].length || _j < 0 )
            throw new _IllegalArrayIndexException();
         else
            return new #(v[_i][_j]);
         java$end
         end
         
      proc set( value : Any; i : integer )
              (exception : CatchAnyArrayException)
          begin
          java$begin
          if ( _i >= size || _i < 0 )
             throw new _IllegalArrayIndexException();
          try { 
              v[_i] =  ($Array$1$_^ ) _value;
          } catch ( Exception e ) {
              throw new _TypeErrorException();
          }
          java$end
          end
          
      proc set( value : Any; i, j : integer )
              (exception : CatchAnyArrayException)
          begin
          java$begin
          if ( _i >= size || _i < 0 ||
               v[_i] == null ||
               _j >= v[_i].length || _j < 0 )
             throw new _IllegalArrayIndexException();
          try { 
              v[_i][_j] =  ((# ) _value)._getValue();
          } catch ( Exception e ) {
              throw new _TypeErrorException();
          }
          java$end
          end
          
       proc getIter() : Iter(^)
          begin
          java$begin
          return new $Iter$Array$2$_^.new(this);
          java$end
          end
          
       proc forEach( f : Function(^) ) 
          begin
          java$begin
          for(int i = 0; i < size; i++)
             if ( v[i] != null ) {
                int length = v[i].length;
                for (int j = 0; j < length; j++)
                  _f._exec(v[i][j]);
             }
          java$end
          end
          
       proc replaceBy( cmd : Command(^) ) 
          begin
          java$begin
          for (int i = 0; i < size; i++)
             if ( v[i] != null ) {
                int length = v[i].length;
                for (int j = 0; j < length; j++)
                   v[i][j] = _cmd._doIt(v[i][j]);
             }
          java$end
          end
          
       proc collect( f : Filter(^) )
                   ( exception : TypeErrorException ) : $Array$2$_^
          begin
          java$begin
          $Array$2$_^ newArray = new $Array$2$_^(size);
          for (int i = 0; i < size; i++)
             if ( v[i] == null ) 
                newArray.v[i] = null;
             else {
                int length = v[i].length;
                boolean indexArray[] = new boolean[length];
                int n = 0;
                int j;
                for (j = 0; j < length; j++) {
                  indexArray[j] = _f._test(v[i][j]);
                  if ( indexArray[j] ) 
                     n++;
                }
                newArray.v[i] = new ?[n];
                int k = 0;
                for (j = 0; j < length; j++)
                   if ( indexArray[j] ) {
                       newArray.v[i][k] = v[i][j];
                       k++;
                   }
             }
          return newArray;
          java$end
          end
          
       proc remove( f : Filter(^) )
          begin
          java$begin
          for (int i = 0; i < size; i++)
             if ( v[i] != null ) {
                int length = v[i].length;
                boolean indexArray[] = new boolean[length];
                int n = 0;
                int j;
                for (j = 0; j < length; j++) {
                  indexArray[j] = _f._test(v[i][j]);
                  if ( indexArray[j] ) 
                     n++;
                }
                ? []w;
                w = new ?[n];
                int k = 0;
                for (j = 0; j < length; j++)
                   if ( indexArray[j] ) {
                       w[k] = v[i][j];
                       k++;
                   }
                v[i] = w;
             }
          java$end
          end
          
          
       proc reset()
          begin
          java$begin
          indexRow = 0;
          indexColumn = 0;
          searchNext();
          java$end
          end
          
       proc more() : boolean
          begin
          java$begin
          return indexRow >= 0;
          java$end
          end
          
       proc next() : Any
          begin
          java$begin
          ? x = element;
          searchNext();
          return x;
          java$end
          end
          
   java$begin
   
       private void searchNext() {
          while ( indexRow < size && 
                  (v[indexRow] == null || v[indexRow].length == 0) )
             indexRow++;
          if ( indexRow >= size )
             indexRow = -1;
          else 
              if ( indexColumn < v[indexRow].length ) {
                 element = v[indexRow][indexColumn];
                 indexColumn++;
              }
              else {
                 indexRow++;
                 indexColumn = 0;
                 searchNext();
              }
       }
       
   public ? [][]v;
   public ? element;
   public int size,  indexRow, indexColumn;
   java$end
   
end
