object double

  public:
  
    proc getSizeInBits() : integer
       // returns the size of a double in bits
       begin
       return 64;
       end
       
    proc getSize() : integer
       // return the size of a double variable in bytes
       begin
       return 8;
       end
      
    proc cast( s : String )
             ( exception : TypeErrorException ) : double
      begin
      java$begin
      try {
         return (new Double(_s)).doubleValue();
      } catch ( Exception e ) {
         throw new PackedException( _TypeErrorException.$classObject._new() );
      }
      java$end
      end
      
      
    proc cast( any : AnyClass )
             ( exception : TypeErrorException ) : double 
      begin
      java$begin
      if ( _any instanceof _Byte )
         return (double ) ((_Byte ) _any)._get();
      else if ( _any instanceof _Integer )
         return (double ) ((_Integer ) _any)._get();
      else if ( _any instanceof _Long )
         return (double ) ((_Long ) _any)._get();
      else if ( _any instanceof _Real )
         return (double ) ((_Real ) _any)._get();
      else if ( _any instanceof _Double )
         return ((_Double ) _any)._get();
      else
         throw new PackedException(_TypeErrorException.$classObject._new());
      java$end
      end
      
    proc cast( value : byte ) : double
       begin
       java$begin
       return (double ) _value;
       java$end
       end
       
    proc cast( value : integer ) : double
       begin
       // return value;
       java$begin
       return (double ) _value;
       java$end
       end
       
    proc cast( value : long ) : double
       begin
       //return value;
       java$begin
       return (double ) _value;
       java$end
       end
       
    proc cast( value : real ) : double
       begin
       //return value;
       java$begin
       return (double ) _value;
       java$end
       end
       
    
    proc castOk( any : AnyClass ) : boolean
      begin
      var aClass : Any = any.getClassObject();
      return aClass == Byte or aClass == Integer or aClass == Long or
             aClass == Real or aClass == Double;
      end
      
      /* each of the following methods is based on a similar constant
         found in the header file "limits.h" of the standard C
         library. The method description is a  copy of the
         description of the corresponding constant as found in K&R. The
         method bodies are dependent on the platform and therefore not
         defined. */
        
    proc getRadix() : integer
       // radix of exponent representation 
       begin
       return 0;
       end
       
    proc getRounds() : integer
       // mode for addition
       begin
       return 0;
       end
       
    proc getPrecision() : integer
       // decimal digits of precision
       begin
       return 0;
       end
       
    proc getEpsilon() : double
       // smaller number e such that 1.0 + e <> 1.0
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
    proc getMantDig() : integer
       // number of base ``getRadix()'' in mantissa
       begin
       return 0;
       end
       
    proc getMinValue() : double
       // minimum double number
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
    proc getMaxValue() : double
       // maximum double number
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
    proc getMaxExp() : double 
       // greater k such that k^n is representable
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
      
    proc getMinExp() : double
       // smaller k such that k^n is a normalized number
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
end


class double subclassOf AnyValue
  public:
  
    proc getInfo() : AnyObjectInfo
       begin
       return nil;
       end
    
  
    proc toString() : String
       begin
       java$begin
       return (new Double(_self)).toString();
       java$end
       end
    proc equals( other : double ) : boolean
         /* returns true if self is equal to other. A warning should be
            issued if this method is used */
       begin
       java$begin
       return _self == _other;
       java$end
       end
    
      /* these operators can only be used with variables. Unlike C++, they
        don't return anything. */
    proc ++()
    proc --()
    
      // unary 
    proc +  () : double    
    proc -  () : double    
      /* binary */
    proc +  ( other : double ) : double    
    proc -  ( other : double ) : double    
    proc *  ( other : double ) : double    
    proc /  ( other : double ) : double    
    
      // comparison. A warning should be issued whenever == or <> is used. 
    proc == ( other : double ) : boolean    
    proc <> ( other : double ) : boolean    
    proc <  ( other : double ) : boolean    
    proc <= ( other : double ) : boolean    
    proc >  ( other : double ) : boolean    
    proc >= ( other : double ) : boolean    

  //private:
  //  var value : lowLevelDouble;
end

   
