object integer

  public:
  
    proc getSizeInBits() : integer
         // returns the size of an integer in bits 
       begin
       return 32;
       end
       
    proc getSize() : integer
       // return the size of an integer variable in bytes 
       begin
       return 4;
       end
      
    proc cast( s : String )
             ( exception : TypeErrorException ) : integer
      begin
      java$begin
      try {
         return (new Integer(_s)).intValue();
      } catch ( Exception e ) {
         throw new PackedException( _TypeErrorException.$classObject._new() );
      }
      java$end
      end
      
      
    proc cast( any : AnyClass )
             ( exception : CatchTypeErrorException ) : integer 
      begin
      java$begin
      if ( _any instanceof _Char )
         return (int ) ((_Char ) _any)._get();
      else if ( _any instanceof _Boolean )
         return ((_Boolean ) _any)._get() ? 1 : 0;
      else if ( _any instanceof _Byte )
         return (int ) ((_Byte ) _any)._get();
      else if ( _any instanceof _Integer )
         return (int ) ((_Integer ) _any)._get();
      else if ( _any instanceof _Long )
         return (int ) ((_Long ) _any)._get();
      else if ( _any instanceof _Real )
         return (int ) ((_Real ) _any)._get();
      else if ( _any instanceof _Double )
         return (int ) ((_Double ) _any)._get();
      else
         throw new PackedException(_TypeErrorException.$classObject._new());
      java$end
      end
      
    proc cast( value : char ) : integer
       begin
       java$begin
       return (int ) _value;
       java$end
       end
       
    proc cast( value : boolean ) : integer
       begin
       java$begin
       return _value ? 1 : 0;
       java$end
       end
       
    proc cast( value : byte ) : integer
       begin
       java$begin
       return (int ) _value;
       java$end
       end
       
    proc cast( value : long ) : integer
         assert 
           before castOk(value);
         end
       begin
       java$begin
       return (int ) _value;
       java$end
       end
      
    proc cast( value : real ) : integer
         assert 
           before castOk(value);
         end
       begin
       java$begin
       return (int ) _value;
       java$end
       end
       
    proc cast( value : double ) : integer
         assert 
           before castOk(value);
         end
       begin
       java$begin
       return (int ) _value;
       java$end
       end
      
    proc castOk( any : AnyClass ) : boolean
      begin
      var aClass : Any = any.getClassObject();
      return aClass == Char or aClass == Boolean or aClass == Byte or
             aClass == Integer or aClass == Long or 
             aClass == Real or aClass == Double;
      end
      
    proc castOk( value : double ) : boolean
      begin
      return value >= integer.getMinValue() and
             value <= integer.getMaxValue();
      end

    proc castOk( value : real ) : boolean
      begin
      return value >= integer.getMinValue() and
             value <= integer.getMaxValue();
      end
      
    proc castOk( value : long ) : boolean
      begin
      return value >= integer.getMinValue() and
             value <= integer.getMaxValue();
      end
  
    proc getMinValue() : integer
      begin
      return -2147483647 - 1;
      end
    proc getMaxValue() : integer
      begin
      return 2147483647;
      end    
end


class integer subclassOf AnyValue
  public:
  
    proc getInfo() : AnyObjectInfo
       begin
       return nil;
       end
    
    proc toString() : String
       begin
       java$begin
       return (new Integer(_self)).toString();
       java$end
       end
    proc equals( other : integer ) : boolean
      // returns true if self is equal to other 
      begin
       java$begin
       return _self == _other;
       java$end
      end
        
    
      /* these operators can only be used with variables. Unlike C++, they
        don't return anything. */
    proc ++()
    proc --()
    
      // unary
    proc +  () : integer    
    proc -  () : integer    
    proc ~  () : integer    
      // binary 
    proc +  ( other : integer ) : integer    
    proc -  ( other : integer ) : integer    
    proc *  ( other : integer ) : integer    
    proc /  ( other : integer ) : integer    
    proc %  ( other : integer ) : integer    
    proc &  ( other : integer ) : integer    
    proc |  ( other : integer ) : integer    
    proc ^  ( other : integer ) : integer    
    proc << ( other : integer ) : integer    
    proc >> ( other : integer ) : integer    
    
      // comparison
    proc == ( other : integer ) : boolean    
    proc <> ( other : integer ) : boolean    
    proc <  ( other : integer ) : boolean    
    proc <= ( other : integer ) : boolean    
    proc >  ( other : integer ) : boolean    
    proc >= ( other : integer ) : boolean    

     /* in the method that follow we assume an integer has at least
       four bytes */
    proc getByte( i : integer ) : byte
       /* returns the value of the i-th byte of the integer. Assume the 0-th byte is the 
          less significant. In some machines this will be the first byte. */
       begin
       java$begin
       return (byte ) ( (_self & (0xFFL << _i*8)) >>> _i*8 );
       java$end
       end
      
  //private:
  //  var value : lowLevelInteger;
    
end

