object long

  public:  
  
    proc getSizeInBits() : integer
       // returns the size of a long in bits 
       begin
       return 64;
       end
      
    proc getSize() : integer
       // return the size of a long variable in bytes 
       begin
       return 8;
       end
       
    proc cast( s : String )
             ( exception : TypeErrorException ) : long
      begin
      java$begin
      try {
         return (new Long(_s)).longValue();
      } catch ( Exception e ) {
         throw new PackedException( _TypeErrorException.$classObject._new() );
      }
      java$end
      end
      
      
    proc cast( any : AnyClass )
             ( exception : TypeErrorException ) : long 
      begin
      java$begin
      if ( _any instanceof _Long )
         return ((_Long ) _any)._get();
      else if ( _any instanceof _Integer )
         return (long ) ((_Integer ) _any)._get();
      else if ( _any instanceof _Byte )
         return (long ) ((_Byte ) _any)._get();
      else if ( _any instanceof _Real )
         return (long ) ((_Real ) _any)._get();
      else if ( _any instanceof _Double )
         return (long ) ((_Double ) _any)._get();
      else 
         throw new PackedException(_TypeErrorException.$classObject._new());
      java$end
      end
      
    proc cast( value : byte ) : long
       begin
       java$begin
       return (long ) _value;
       java$end
       end
       
    proc cast( value : integer ) : long
       begin
       java$begin
       return (long ) _value;
       java$end
       end
       
    proc cast( value : real ) : long
          assert
             before castOk(value);
          end  
       begin
       java$begin
       return (long ) _value;
       java$end
       end
       
    proc cast( value : double ) : long
          assert
             before castOk(value);
          end  
       begin
       java$begin
       return (long ) _value;
       java$end
       end
       
      
    proc castOk( any : AnyClass ) : boolean
      begin
      var aClass : Any = any.getClassObject();
      return aClass == Long or aClass == Integer or aClass == Byte or
             aClass == Real or aClass == Double;
      end
      
    proc castOk( value : double ) : boolean
      begin
      return value >= long.getMinValue() and
             value <= long.getMaxValue();
      end

    proc castOk( value : real ) : boolean
      begin
      return value >= long.getMinValue() and
             value <= long.getMaxValue();
      end
      
    proc getMinValue() : long
      begin
      return -2147483647L*2147483647L - 1L;
      end
      
    proc getMaxValue() : long
      begin
      return 2147483647L*2147483647L;
      end    
      
end


class long subclassOf AnyValue
  public:
  
    proc getInfo() : AnyObjectInfo
       begin
       return nil;
       end
    
  
    proc toString() : String
       begin
       java$begin
       return (new Long(_self)).toString();
       java$end
       end
    proc equals( other : long ) : boolean
       begin
       java$begin
       return _self == _other;
       java$end
       end
      // returns true if self is equal to other 
    
      /* these operators can only be used with variables. Unlike C++, they
         don't return anything. */
    proc ++()
    proc --()
    
      // unary 
    proc +  () : long    
    proc -  () : long    
    proc ~  () : long    
      // binary 
    proc +  ( other : long ) : long    
    proc -  ( other : long ) : long    
    proc *  ( other : long ) : long    
    proc /  ( other : long ) : long    
    proc %  ( other : long ) : long    
    proc &  ( other : long ) : long    
    proc |  ( other : long ) : long    
    proc ^  ( other : long ) : long    
    proc << ( other : integer ) : long    
    proc >> ( other : integer ) : long    
    
      // comparison 
    proc == ( other : long ) : boolean    
    proc <> ( other : long ) : boolean    
    proc <  ( other : long ) : boolean    
    proc <= ( other : long ) : boolean    
    proc >  ( other : long ) : boolean    
    proc >= ( other : long ) : boolean    
    
     /* in the method that follow we assume a long has at least
        eight bytes */
        
    proc getByte( i : integer ) : byte
       /* returns the value of the i-th byte of the long. Assume the 0-th byte is the 
          less significant. In some machines this will be the first byte. */
       begin
       java$begin
       return (byte ) ( (_self & (0xFFL << _i*8)) >>> _i*8 );
       java$end
       end

      
  //private:
  //  var value : lowLevelLong;
end

