package CompilerError;
  // a list of error of a specific class. Each class is associated to a single file (like in Java).
  
import java.util.*;
import java.io.*;

public class ClassErrorList {
    
   public ClassErrorList(String directory, String fileName) {
      list = new Vector();
      this.directory = directory;
      this.fileName = fileName;
   }
   
   public void add( ClassError ce ) {
      list.addElement(ce);
   }
   
   public Enumeration elements() {
      return list.elements();
   }
   
   public String getDirectory() {
      return directory;
   }
   
   public String getFileName() {
      return fileName;
   }
   
   public String getPath() {
      return directory + File.separator + fileName;
   }
   
   public void print( PrintWriter out ) {
      String path = directory + File.separator + fileName;
      Enumeration e = list.elements();
      while ( e.hasMoreElements() ) {
         out.print(path);
         ClassError anError = (ClassError ) e.nextElement();
         if ( anError.getLineNumber() > 0 ) {
            out.println(":line(" + 
               anError.getLineNumber() + ") Column(" +
               anError.getColumnNumber() + "): ");
            if ( anError.getLineWithError() != null ) 
               out.println( anError.getLineWithError() );
         }
         else 
            out.println();
         out.println( "Error: " + anError.getMessage() );
      }
      out.flush();
   }
   
   public int getSize() {
      return list.size();
   }
   
   
   private Vector list;
   private String directory, fileName;
      
}