package CompilerError;

import java.io.*;
import java.util.*;
import GreenCompiler.*;

public class ErrorMsgList extends ErrorMsg {

  public ErrorMsgList( ClassErrorList basicErrorList ) {
    super( new PrintWriter(System.out) );
    wasAnCompilerError = false;
    this.basicErrorList = basicErrorList;
    staticBasicErrorList = basicErrorList;
  }
  
  
  public void setClassErrorList(ClassErrorList classErrorList) {
     this.classErrorList = classErrorList;
  }

  public void removeClassErrorList() {
     classErrorList = basicErrorList;
  }
  
  
  public void setLexer( MyLexer lexer ) {
    this.lexer = lexer;
  }
  
  public void setFileName( String fileName ) {
    throw new RuntimeException("setFileName at ErrorMsgList");
  }

  public void setShowNameLineColumn(boolean showNameLineColumn) {
    throw new RuntimeException("setShowNameLineColumn at ErrorMsgList");
  }

  public void show(String msg, int lineNumber, int columnNumber ) {

     ClassError ce = new ClassError(lineNumber, columnNumber, 
           msg, lexer.getCurrentLine() );
     classErrorList.add(ce);
     wasAnCompilerError = true;
     throw new CompilerException();
  }

  public void show(String msg ) {
     show(msg, lexer.getLineNumber(), lexer.getColumnNumber() );
  }

  public void signal(String msg ) {

     show(msg);
     throw new CompilerException();
  }

  public boolean getWasAnCompilerError() {
    return wasAnCompilerError;
  }

  public static void signalFatalError( String msg ) {
     ClassError ce = new ClassError(0, 0, msg, "");
     staticBasicErrorList.add(ce);
     // there is an error in this compiler. An error may be signalled but
     // wasAnCompilerError may be true. This only occurs in case of
     // an internal error. I hope.
     // wasAnCompilerError = true;
     throw new CompilerException();
  }

  private MyLexer lexer;
  private boolean wasAnCompilerError;
  
  private ClassErrorList basicErrorList; 
  private ClassErrorList classErrorList;
  private static ClassErrorList staticBasicErrorList;
}
