package GreenCompiler;

import CompilerError.*;

import java.io.*;

public class ProjectErrorList extends ProjectError {
    
  public ProjectErrorList() {
     super(new PrintWriter(System.out));
     setWasACompilerError(false);
  }
  
  public void setClassErrorList( ClassErrorList classErrorList ) {
     this.classErrorList = classErrorList;
  }
 
  public void show(String msg, int lineNumber ) {
    
     if ( lineNumber == -1 ) 
        classErrorList.add( new ClassError(1, 1, msg, null) );
     else 
        classErrorList.add( new ClassError(lineNumber, 1, msg, null) );

     setWasACompilerError(true);
  }

  public void show( String msg ) {
    show(msg, -1);
  }
  
  public void signal(String msg, int lineNumber ) {
     show(msg, lineNumber);
     throw new ProjectException();
  }
  
  
  private ClassErrorList classErrorList;
}
