package GreenCompiler;

import CompilerError.*;
import java.io.*;
import java.util.*;

public class gc {

    public static void main( String []args ) {
        if ( args.length < 1  )  {
            printUsage1();
        }
        else {
            String projectFileName;
            if ( args[0].indexOf(".gp") < 0 ) {
               if ( args.length != 2 ) {
                  System.out.println("Usage:\n   gc input dir");
                  System.out.println("input is the file with a list of filenames.");
                  System.out.println("This file should not have the extension \"gc\"");
                  System.out.println("dir is the directory in which the compiler is.");
                  return ;
               }
               if ( (projectFileName = createProject(args[0], args[1])) == null )
                  return;
            }
            else {
               projectFileName = args[0];
               if ( args.length != 1 ) {
                  printUsage1();
                  return ;
               }
            }
               
            ClassErrorListList cell;
            cell = (new gc()).compile(projectFileName);
            cell.print( new PrintWriter(System.out) );
        }
    }
    
    
    public ClassErrorListList compile( String projectFileName ) {
        
       ClassErrorListList errorListList = new ClassErrorListList();
       ProjectErrorList projectErrorList = new ProjectErrorList();
       ClassErrorList classErrorList = new ClassErrorList("", projectFileName);
       errorListList.addAnyway(classErrorList);
       projectErrorList.setClassErrorList(classErrorList);
       
       ClassErrorList cel = new ClassErrorList("", "");
       ErrorMsgList errorMsgList = new ErrorMsgList(cel); 
       errorListList.add(cel);
       
       GreenProject gp = new GreenProject();
       if ( gp.init( projectFileName, 
              // new ProjectError(new PrintWriter(System.out)),
              projectErrorList,
              //new ErrorMsg(new PrintWriter(System.out)),
              errorMsgList,
              errorListList
              ) )
           gp.make();
       return errorListList;
    }
    
    
    private static String createProject(
                             String listFileName,
                             String compilerDirectory
                             ) {
        File f, g;
        String outputFileName;
        FileOutputStream outputStream;
        
        if ( ! compilerDirectory.endsWith("\\") ) 
           compilerDirectory += "\\";
        
        f = new File(listFileName);
        g = new File(f.getAbsolutePath());
        outputFileName = listFileName;
        int lastIndex;
        if ( (lastIndex = outputFileName.lastIndexOf('.')) == -1 )
           lastIndex = outputFileName.length();
        StringBuffer sb = new StringBuffer(outputFileName.substring(0, lastIndex));
        sb.append(".gp");
        outputFileName = sb.toString();
        try { 
           outputStream = new FileOutputStream(outputFileName);
        } catch ( IOException e ) {
           System.out.println("File " + outputFileName + " could not be created");
           return null;
        }
        PrintWriter printWriter = new PrintWriter(outputStream);
        MyFile inputFile = new MyFile(listFileName);
        char in[] = inputFile.readFile();
        in[in.length-1] = ' ';
        printWriter.print(in);
        printWriter.println();
        printWriter.println("*options");
        printWriter.println("useirl");
        printWriter.println("arraydir = " +
           compilerDirectory + "test1\\arraytmp");
        printWriter.println("classdir = " +
           compilerDirectory + "test1\\classtmp");
        printWriter.println("interfacedir = " + compilerDirectory + 
               "test1\\interface");
        printWriter.println("projectdir = " + g.getParent());
        printWriter.println("basiclib = " + compilerDirectory + "BasicTypes" );
        printWriter.println("wrapper = " + compilerDirectory + "Wrapper");
        printWriter.println("templatedir = " + compilerDirectory 
           + "ArrayCreate");
        printWriter.println("lib = " + compilerDirectory + "IRL");
        printWriter.println("lib = " + compilerDirectory + "BasicArrays");
        printWriter.println("lib = " + compilerDirectory + "exceptionlib");
        printWriter.println("lib = " + compilerDirectory + "GreenLib");
        printWriter.println("lib = " + compilerDirectory + "GreenLib\\DS");
        printWriter.close();
        return outputFileName;
    }
    
   private static void printUsage1() {
      System.out.println("Usage:\n   gc input ");
      System.out.println("input is the project file");
   }
}