object Runtime

     proc init()
       begin
       endList = List(Action).new();
       catchObjectStack = Vector(Catch).new();
       end
       
   public:
   
      proc exit( errorCode : integer )
         begin
         java$begin
         System.exit(_errorCode);
         java$end
         end
         
      proc putAtEndList( f : Action )
         begin
         try(HCatchAll)
            endList.add(f);
         end
         end
         
      proc getClasses() : array(ClassInfo)[]
         begin
         return arrayCI;
         end
         
      proc $setClasses( arrayCI : array(ClassInfo)[] )
         begin
         self.arrayCI = arrayCI;
         end
         
      proc searchForClass( name : String ) : ClassInfo
            var i : integer;
         begin
         for i = 0 to arrayCI.getSize() - 1 do
            if arrayCI[i].getName().compareTo(name) == 0 
            then
               return arrayCI[i];
            endif
         return nil;
         end
         
      proc getMethodCallStack() 
              ( exception : CatchNoReflectiveCallInfoException )
              : Stack(MethodCallInfo)
         begin
         if methodCallStack == nil
         then
            exception.throw( NoReflectiveCallInfoException.new() );
         endif
         return methodCallStack;
         end
         
      proc $addMethodCallStack( methodCall : MethodCallInfo )
         begin
         try(HCatchAll)
            methodCallStack.add(methodCall);
         end
         end

      proc $removeMethodCallStack()
         begin
         try(HCatchAll)
            methodCallStack.remove();
         end
         end
         
      proc getCatchObjectStack() : Stack(Catch)
         begin
         return catchObjectStack;
         end

      proc $addCatchObjectStack( catch : Catch ) 
         begin
         /*
         if catch.getClassInfo() <> null and
            catch.getClassInfo().getName().compareTo("AnyClassObject") == 0 
         then
            Out.writeln("anyclassobject found");
            exit(0);
         endif
         */
         java$begin
            //try(HCatchAll)
            //catchObjectStack.add(catch);
            //end
            
            (($pc$Vector$1$_Catch ) _catchObjectStack)._add$_Catch(_catch);
         java$end
         end
         
      proc $removeCatchObjectStack() 
         begin
         java$begin
            try {
               (($mi$remove$0$_Catch ) this._catchObjectStack)._remove();
            } catch ( Throwable e ) { 
               System.out.println("Error at removeCatchObjectStack()");
               System.exit(1);
            }
         java$end
         /* try(HCatchAll)
            catchObjectStack.remove();
         end
         */
         end
         
      proc getMethodThrownException()
              ( exception : CatchNoExceptionInfoException ) 
                : ObjectMethodInfo
         begin
         return methodThrownException;
         end
         
      proc $setMethodThrownException( methodThrownException : ObjectMethodInfo )
         begin
         self.methodThrownException = methodThrownException;
         end
         
      proc getNameMethodThrownException()
              ( exception : CatchNoExceptionInfoException ) : String
         begin
         return nameMethodThrownException;
         end
         
      proc $setNameMethodThrownException( nameMethodThrownException : String )
         begin
         self.nameMethodThrownException = nameMethodThrownException;
         end
         
         
      /*   
      proc getClassThrownException()
              ( exception : CatchNoExceptionInfoException ) : ClassInfo
         begin
         return classThrownException;
         end
         
      proc $setClassThrownException( classThrownException : ClassInfo )
         begin
         self.classThrownException = classThrownException;
         end
      */
      
      proc setCatchUnchecked( myCatch : CatchUncheckedException )
         begin
         try(HCatchAll)
            catchObjectStack.add(myCatch, 0);
         end
         end
         
      proc getCatchUnchecked() : Catch
         begin
         try(HCatchAll)
            return catchObjectStack.get(0);
         end
         return nil;
         end

   private:
      var 
         endList : List(Action);
         methodThrownException : ObjectMethodInfo;
         nameMethodThrownException : String;
         catchObjectStack : Vector(Catch);
         methodCallStack : Stack(MethodCallInfo);
         classThrownException : ClassInfo;
         arrayCI : array(ClassInfo)[];
end      
      
