abstract class AnyObjectInfo

   proc init( 
         arrayIVI : array(ObjectInstanceVariableInfo)[];
         arrayMI  : array(ObjectMethodInfo)[];
         typeI    : ClassInfo
         )
      begin
      self.arrayIVI = arrayIVI;
      self.arrayMI = arrayMI;
      self.typeI = typeI;
      end
      
      
   public:
   
      abstract proc getObject() : Any
         
      proc getInstanceVariables() : array(ObjectInstanceVariableInfo)[]
         begin
         return arrayIVI;
         end
         
      proc getMethods() : array(ObjectMethodInfo)[]
         begin
         return arrayMI;
         end
         
      proc getPublicMethods() : array(ObjectMethodInfo)[]
            var j : integer;
                v : Vector(ObjectMethodInfo);
         begin
         v#init();
         for j = 0 to arrayMI.getSize() - 1 do
            if arrayMI[j].getVisibility() == MethodInfo.public_v
            then
               try(HCatchAll)
                  v.add( arrayMI[j] );
               end
            endif
         return v.toArray();
         end

            
      proc getPublicMethod( name : String ) : array(ObjectMethodInfo)[]
            var j : integer;
                v : Vector(ObjectMethodInfo);
         begin
         v#init();
         for j = 0 to arrayMI.getSize() - 1 do
            if arrayMI[j].getVisibility() == MethodInfo.public_v  and
               arrayMI[j].getName().compareTo(name) == 0
            then
               try(HCatchAll)
                  v.add( arrayMI[j] );
               end
            endif
         return v.toArray();
         end
            
         
      proc getMethod( name : String; paramTypes : array(ClassInfo)[] ) : array(ObjectMethodInfo)[]
            var v : Vector(ObjectMethodInfo);
         begin
         v#init();
         for i : integer = 0 to arrayMI.getSize() - 1 do
            if arrayMI[i].matchInterface(name, paramTypes)
            then
               try(HCatchAll)
                  v.add( arrayMI[i] );
               end
            endif
         return v.toArray();
         end
      
      
      proc getMethod( name : String ) : ObjectMethodInfo
         begin
         var i : integer  = 0;
         var size : integer = arrayMI.getSize();
         while i < size do
            if arrayMI[i].getName().compareTo(name) == 0
            then
               return arrayMI[i];
            else
               ++i;
            endif
         return nil;
         end
      
      
      proc getInstanceVariable( name : String ) : ObjectInstanceVariableInfo
         begin
         var i : integer  = 0;
         var size : integer = arrayMI.getSize();
         while i < size do
            if arrayIVI[i].getName().compareTo(name) == 0
            then
               return arrayIVI[i];
            else
               ++i;
            endif
         return nil;
         end
      
      
      proc getTypeInfo() : ClassInfo
         begin
         return typeI;
         end
         
   private:
      var 
         arrayIVI : array(ObjectInstanceVariableInfo)[];
         arrayMI  : array(ObjectMethodInfo)[];
         typeI    : ClassInfo;
         
end      