class ObjectMethodInfo subclassOf MethodInfo

   proc init( 
         name : String;
         methodNumber : integer;
         methodBodyInfo : MethodBodyInfo;
         visibility : integer;
         arrayPT : array(ClassInfo)[];
         returnType : ClassInfo;
         arrayPI : array(ParameterInfo)[];
         exceptionI : ClassInfo;
         codeAnnotation : array(CodeAnnotation)[]
         )
      begin
      super.init( name, methodBodyInfo, visibility, arrayPT, returnType, arrayPI, 
         exceptionI, codeAnnotation );
      self.methodNumber = methodNumber;         
      end
      
   proc init( m : ClassMethodInfo ) 
      begin
      self.init( m.getName(), m.getMethodNumber(), m.getBodyInfo(), m.getVisibility(), 
        m.getParameterTypes(), m.getReturnType(), m.getParameters(), 
        m.getExceptionClass(), m.getNotes() );
      end
      
   public:
   
      proc getMethodNumber() : integer
         begin
         return methodNumber;
         end
         
   
      proc setObject( obj : Any ) 
         begin
         self.obj = obj;
         end
         
      proc invoke( args : array(Any)[] )
                 ( exception : CatchInvokePackedException ) : Any
         begin
         java$begin
         return _obj.$callMethod(_methodNumber, _args);
         java$end
         end

      //c
      /*proc invoke_v( args : ...array(Any)[] )
                   ( exception : CatchInvokePackedException) : Any
         begin
         java$begin
         return _obj.$callMethod(_methodNumber, _args);
         java$end
         end
      */
         
   private:
      var methodNumber : integer;
          obj : Any;
      
end               