import java.io.*;

public class CreProj {
    public static void main( String []args ) {
        if ( args.length != 2 ) {
            System.out.println("This program should have two and only two arguments");
            System.out.println("The first is the directory in which the directories of the tests are");
            System.out.println("The second is the directory 'compiler' in which the compiler is.");
            System.out.println("Example: ");
            System.out.println("    java CreProj . c:\\jose\\green\\compiler");
            return;
        }
        File dir = new File(args[0]);
        String compileDir = args[1];
        if ( ! dir.isDirectory() || ! dir.canRead() ) {
            System.out.println("Cannot read " + args[0] + " or it does not exist");
            return ;
        }
        String dirNames[] = dir.list();
        for (int i = 0; i < dirNames.length; i++) {
            File aDir = new File(dirNames[i]);
            String name = dirNames[i].toLowerCase();
            if ( (name.startsWith("ok") ||
                  name.startsWith("er")) &&
                  aDir.isDirectory() ){
                /*
                try {
                System.out.println("getPath = " + aDir.getPath() );
                System.out.println("getAbsolutePath = " + aDir.getAbsolutePath() );
                System.out.println("getCanonicalPath = " +
                   aDir.getCanonicalPath() );
                System.out.println("getParent = " + aDir.getParent());
                System.out.println("getName = " + aDir.getName());
                } catch (Exception e ) {}
                */
                createProject( aDir.getAbsolutePath(), compileDir );
            }
        }
    }
    public static void createProject(String path, String compileDir) {
        File f = new File(path);
        PrintWriter out = null;
        FileOutputStream fos = null;
        try {
           fos = new FileOutputStream(path + File.separator 
              + "proj.gp");
           out = new PrintWriter(fos);
        } catch ( Exception e ) { return ; }
        
        out.println("Program");
        String []fn = f.list();
        for (int i = 0; i < fn.length; i++) {
            String name = fn[i].toLowerCase();
            if ( name.endsWith(".g") && 
                 name.compareTo("program.g") != 0 ) {
               String className = fn[i].substring(0, name.indexOf(".g"));
               out.println(className);
            }
        }
        out.println("*options");
        out.println("useirl");
        
        /*
        out.println("arraydir = c:\\jose\\green\\compiler\\test1\\arraytmp");
        out.println("classdir = c:\\jose\\green\\compiler\\test1\\classtmp");
        out.println("interfacedir = c:\\jose\\green\\compiler\\test1\\interface");
        out.println("projectdir = " + path);
        
        out.println("basiclib = c:\\jose\\green\\compiler\\BasicTypes");
        out.println("wrapper = c:\\jose\\green\\compiler\\Wrapper");
        out.println("templatedir = c:\\jose\\green\\compiler\\ArrayCreate");
        out.println("lib = c:\\jose\\green\\compiler\\IRL");
        out.println("lib = c:\\jose\\green\\compiler\\BasicArrays");
        out.println("lib = c:\\jose\\green\\compiler\\exceptionlib");
        out.println("lib = c:\\jose\\green\\compiler\\GreenLib");
        out.println("lib = c:\\jose\\green\\compiler\\GreenLib\\DS");
        */
        out.println("arraydir = " + compileDir + "\\test1\\arraytmp");
        out.println("classdir = " + compileDir + "\\test1\\classtmp");
        out.println("interfacedir = " + compileDir + "\\test1\\interface");
        out.println("projectdir = " + path);
        
        out.println("basiclib = " + compileDir + "\\BasicTypes");
        out.println("wrapper = " + compileDir + "\\Wrapper");
        out.println("templatedir = " + compileDir + "\\ArrayCreate");
        out.println("lib = " + compileDir + "\\IRL");
        out.println("lib = " + compileDir + "\\BasicArrays");
        out.println("lib = " + compileDir + "\\exceptionlib");
        out.println("lib = " + compileDir + "\\GreenLib");
        out.println("lib = " + compileDir + "\\GreenLib\\DS");
        out.close();
    }
}