/*

   ok-sem32.g
   
   tests the shallowClone method.
*/

object A
   public:
      proc print()
         begin
         Out.write("a = ");
         Out.writeln(a);
         Out.write("b = ");
         Out.writeln(b);
         end
      proc set( a, b : integer )
         begin
         self.a = a;
         self.b = b;
         end
   private:
      var a, b : integer;
end

class A 
     proc init( a1 : integer; a2 : char )
        begin
        self.a1 = a1;
        self.a2 = a2;
        end
   public:
      proc print() 
         begin
         Out.write("a1 = ");
         Out.writeln(a1);
         Out.write("a2 = ");
         Out.writeln(a2);
         end
   private:
      var a1 : integer;
          a2 : char;
end        


class B subclassOf A
      proc init( b1 : integer )
         begin
         super.init(10, 'S');
         self.b1 = b1;
         b2 = A.new(65, 'A');
         end
   public:
      proc print()
         begin
         super.print();
         Out.write("b1 = ");
         Out.writeln(b1);
         Out.writeln("b2 : ");
         b2.print();
         end
   private:
      var b1 : integer;
          b2 : A;
end          


object Program
   public:
      proc run()
           var b, clone_b : B;
               a, clone_a : A;
               
         begin
         a = A.new(0, '$');
         Out.writeln("a : ");
         a.print();
         Out.writeln("");
         
         clone_a = nil;
         try(HCatchAll)
            clone_a = A.cast(a.shallowClone());
         end
         Out.writeln("clone_a : ");
         clone_a.print();
         Out.writeln("");
         
         b = B.new(1);
         Out.writeln("b : ");
         b.print();
         Out.writeln("");
         
         clone_b = nil;
         try(HCatchAll)
            clone_b = B.cast( b.shallowClone() );
         end
         Out.writeln("clone_b : ");
         clone_b.print();
         Out.writeln("");
         
         Out.writeln("Now the class objects");
         A.set(5, 7);
         A.print();
         try(HCatchAll)
            var other_A : type(A) = A.castObject(A.shallowClone());
            other_A.print();
         end
         
         end
end         
         