/*
  ok-sin24.g
  
  Tests if catch objects are removed from the stack of catch objets.
*/

class A subclassOf Exception
end

class C subclassOf Exception
end

class B 
   public:
      proc throw( exc : A )
         begin
         Out.writeln("Exception A thrown in B");
         end
      proc throw( exc : C )
         begin
         Out.writeln("Exception C thrown in B");
         end
end         

class D 
   public:
      proc throw( exc : C )
         begin
         Out.writeln("Exception C thrown in D");
         end
      proc throw( exc : A )
         begin
         Out.writeln("Exception A thrown in D");
         end
end         

class E 
   public:
      proc throw( exc : C )
         begin
         Out.writeln("Exception C thrown in E");
         end
end

object Program 
   public:
      proc m()(exception : B)
         begin
         p();
         end
      proc p()(exception : B)
         begin
         exception.throw( A.new() );
         end
      proc run()
         begin
         try(B.new())
            try(D.new())
            end
         end
         Out.writeln("Outside any try");
         print();
         Out.writeln("After print");
         try(B.new())
            try(D.new())
               try(E.new())
                  Out.writeln("Inside triple try");
                  print();
                  //m();
               end
            end
         end
         end
         
      proc print()
            var i : integer;
         begin
         i = 0;
         var stack : Stack(Catch) = Runtime.getCatchObjectStack();
         var iter : Iter(Catch) = stack.getIter();
         while iter.more() do
            begin
            var aCatch : Catch = iter.next();
            Out.write(i);
            ++i;
            Out.writeln( aCatch.getClassInfo().getName() );
            var pm : array(ClassMethodInfo)[] = aCatch.getClassInfo().getPublicMethods();
            for j : integer = 0 to pm.getSize() - 1 do
               if pm[j].getName().compareTo("throw") == 0 
               then
                  Out.write("    throw(");
                  var ci : array(ClassInfo)[] = pm[j].getParameterTypes();
                  Out.write(ci[0].getName());
                  Out.writeln(")");
               endif
            end
         end
end         